#include "include/bcl.h"

int mask_multiply(int (*ground)[LENGTH], struct point *p)
{
	int result = 0;
	int mask[4] = {1, 1, 1, 1};
	int *point;
	int i;
		
	point = &ground[p->x][p->y];

	for (i = 0;i < 4;i++)
	{
		result = result * 10 + mask[i] * (*point);

		if (i == 1)
			point += (LENGTH - 1);
		else
			point++;
	}

	return result;
}


struct point get_naive_available_point(int color, struct block_size size)
{
	int i, j;
	int (*ground)[LENGTH];
	int available = 0;
	struct point place_point;
	
	ground = get_stage();
	
	for (i = 0;i < LENGTH;i++)
	{
		for (j = 0;j < LENGTH - 1;j++)
		{	
			if (ground[i][j] == color && ground[i][j+1] == EMPTY)
			{
				place_point.x = i;
				place_point.y = j;
				
				available = mask_multiply(ground, &place_point);	

				if (available == color * 1000)
				{
					place_point.x += 1;
					place_point.y += 1;

					return place_point;
				}
			}
		}
	}

	place_point.x = -1;
	place_point.y = -1;
	
	return place_point;
}

/* 
	fool_player :
	@color : team color
	Description :
	Our fool player algorithm places a block to ground by stupid manner.
	All the blocks will be placed to diagonal direction from top-left position to bottom-right position. 
	An algorithm returns OUT_OF_SPACE, if there are no more positions which can be placed by algorithm. For example, if an enemy's block is placed to bottom-right of player's last placed block, the algorithm can not find the position to place a block.
 */

int fool_player(int color)
{
	struct block *sets, *target;	
	struct block_size size;
	struct point place_point;
	int (*ground)[LENGTH];
	int i = 0;
	int ret, done;
	int in_ground = 0;

	sets = get_blocks(color);
	ground = get_stage();		
	ret = 0;
	done = 0;

	while (i < BLOCK_NUM && sets[i].place == IN_STAGE)
	{
		in_ground++;
		i++;
	}
	
	while (!done)
	{
		if (in_ground == BLOCK_NUM)
			return OUT_OF_BLOCK;

		if (i > BLOCK_NUM || ret > NOERROR)
			return OUT_OF_SPACE;

		target = &sets[i++];

		/* 
			If the target block is in block set,
			we can place the block to the ground
		*/

		if (target->place == IN_STAGE)
		{
			in_ground++;
			
			continue;
		}

		size = get_block_size(target->block);
		
		if (ground[0][0] == 0)
		{
			place_point.x = 0;
			place_point.y = 0;
		}
		else
		{
			place_point = get_naive_available_point(color, size);

			if (place_point.x == -1)
			{
				ret = OUT_OF_STAGE;

				continue;
			}
	
			if (((place_point.x + size.height - 1) >= LENGTH) || 
				((place_point.y + size.width - 1) >= LENGTH))
				continue;
		}
		
		place_point.x += size.height - 1;


		/* fool player does not use rotate and flip function */
		//rotate(target, 1);
		//flip(target);

		ret = place_to(target, place_point.x, place_point.y);

		if (ret == NOERROR)
			done = 1;
	}
	
	return PLAYING;
}
